searchNodes=[{"doc":"A use macro for automatically generating a Bitmask from a collection of atoms, with support for saving them to a database via the provided Ecto.Type. You can create a bitmask like so: defmodule MyBitmask do use Bitmask , [ :flag_1 , :flag_2 , :flag_3 , :flag_4 , ] end Or, you can define specific values for each field: defmodule MyBitmask do import Bitwise use Bitmask , [ flag_1 : 1 &lt;&lt;&lt; 0 , flag_2 : 1 &lt;&lt;&lt; 1 , flag_3 : 1 &lt;&lt;&lt; 2 , flag_4 : 1 &lt;&lt;&lt; 3 , ] end The generated bitmask can also optinally be used with ecto. It stores the flags in the DB as a bigint: defmodule SomeEctoSchema do use Ecto.Schema schema &quot;bitmasks&quot; do field :my_bitmask , MyBitmask end end","ref":"Bitmask.html","title":"Bitmask","type":"behaviour"},{"doc":"Converts a list of atoms into a bitmask iex&gt; MyBitmask . atom_flags_to_bitmask ( [ :flag_1 , :flag_3 ] ) % MyBitmask { bitmask : 5 , flags : [ :flag_1 , :flag_3 ] }","ref":"Bitmask.html#c:atom_flags_to_bitmask/1","title":"Bitmask.atom_flags_to_bitmask/1","type":"callback"},{"doc":"Converts an atom from the bitmask into its underlying value iex&gt; MyBitmask . atom_to_bitmask ( :flag_3 ) 4","ref":"Bitmask.html#c:atom_to_bitmask/1","title":"Bitmask.atom_to_bitmask/1","type":"callback"},{"doc":"Returns the a list of all the bitmasks flags iex&gt; MyBitmask . get_all_values ( ) [ flag_1 : 1 , flag_2 : 2 , flag_3 : 4 , flag_4 : 8 ]","ref":"Bitmask.html#c:get_all_values/0","title":"Bitmask.get_all_values/0","type":"callback"},{"doc":"Checks if a bitmask has a flag set iex&gt; bitmask = MyBitmask . int_to_bitmask ( 3 ) % MyBitmask { bitmask : 3 , flags : [ :flag_1 , :flag_2 ] } iex&gt; MyBitmask . has_flag ( bitmask , :flag_2 ) true","ref":"Bitmask.html#c:has_flag/2","title":"Bitmask.has_flag/2","type":"callback"},{"doc":"Converts an integer into a bitmask iex&gt; MyBitmask . int_to_bitmask ( 3 ) % MyBitmask { bitmask : 3 , flags : [ :flag_1 , :flag_2 ] }","ref":"Bitmask.html#c:int_to_bitmask/1","title":"Bitmask.int_to_bitmask/1","type":"callback"},{"doc":"A bitmask implementation for elixir, with optional Ecto support.","ref":"readme.html","title":"Bitmask","type":"extras"},{"doc":"Define your bitmask defmodule MyBitmask do use Bitmask , [ :flag_1 , :flag_2 , :flag_3 , :flag_4 , ] end Create your bitmask iex&gt; bitmask = MyBitmask . atom_flags_to_bitmask ( [ :flag_1 , :flag_3 ] ) % MyBitmask { bitmask : 5 , flags : [ :flag_1 , :flag_3 ] } Check if we have a flag iex&gt; MyBitmask . has_flag ( bitmask , :flag_1 ] ) true Store it in an Ecto schema defmodule SomeEctoSchema do use Ecto.Schema schema &quot;bitmasks&quot; do field :my_bitmask , MyBitmask end end See the docs for more info. Issues / PRs / Feedback welcome.","ref":"readme.html#usage","title":"Bitmask - Usage","type":"extras"}]